/*

The Life of a Geek
Copyright (C) 2003 Daniel Quintiliani

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

You can e-mail Daniel Quintiliani at coredump@coredumpcentral.org

display.cc - Handles the menus and display.

7/4/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Updated code for new
readfromfilevars(), added hacker battling code, fixed bug where gpl check
be done in certain spots.
6/14/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Fixed support for
older compilers/C libraries.
6/13/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Added elapsed time
code.
5/21/03: Daniel Quintiliani <coredump@coredumpcentral.org>: WasteTime() updated.
5/20/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Transfer to text
files (almost) complete, pauses after showing statistics now.
4/24/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Removed ShowMenu(),
fixed a bug where you would be stuck in an infinite loop in the caffeine
menu, fixed a bug where you could drink energy drinks you didn't have,
fixed a bug where "show w" and "show c" had to be lowercase at one part
of the game, fixed a bug where you would be stuck if you had no energy
and money instead of falling asleep, fixed a bug where energy would not be
deducted after leaving the caffeine menu, fixed a bug where only
one energy drink would be purchased instead of what user specified, game.lg
now used.
4/7/03: Daniel Quintiliani <coredump@coredumpcentral.org>: To be more
considerate replaced all bools with ints, gpl_check() and
gpl_check_and_strlwr() put in, fixed a bug where a class would be taken 
anyway even if you told it not to.

*/

#include "func.h"
#include <iostream>
#include "display.h"

using namespace std;

void ShowStats(Geek &geek, Computer comp, ElTime &elt)
{
	if( geek.GetEnergy() < 10 )
	{
		cout << readfromfilevars(MAINFILE,"!NOENERGY",0,geek,comp,comp,elt,10,0,"","","");	
		return;
	}
	else
	{ 
		geek.SetEnergy(geek.GetEnergy() - 10);
		string sInfVir = readfromfile(MAINFILE,"!INFVIR",1);
		string sNoInfVir = readfromfile(MAINFILE,"!NOINFVIR",1);
		cout << readfromfilevars(MAINFILE,"!STATS",0,geek,comp,comp,elt,
			0,0,"",sInfVir.c_str(),
			sNoInfVir.c_str());
		cout << readfromfile(MAINFILE,"!PAUSE",1);
		getline(cin,sInfVir);
		gpl_check_and_strlwr(sInfVir);
		elt.AddMin(10);
	}
}

void SpeedClass(Geek &geek, Computer &comp, ElTime &elt)
{
	string s = "show w";

	while(s == "show w" || s == "show c" )
	{
		cout << readfromfile(MAINFILE,"!SPDCLASS",0);
		cout << readfromfile(MAINFILE,"!PDOIT",1);
		getline(cin, s);
		gpl_check_and_strlwr(s);
	}

	if(s[0] == 'y' && geek.GetMoney() < 1500)
	{
		cout << readfromfile(MAINFILE,"!NOMONEY",0);
		return;
	}
	else if(s[0] == 'y')
		CmdSpeedClass(geek, comp,elt);
}

void Work(Geek &geek, Computer &comp, ElTime &elt)
{
	string s = "show w";

	while(s == "show w" || s == "show c" )
	{
		cout << readfromfile(MAINFILE,"!JOB",0);
		cout << readfromfile(MAINFILE,"!PDOIT",1);
		getline(cin, s);
		gpl_check_and_strlwr(s);
	}
	
	if(s[0] == 'y')
		CmdWork(geek, comp,elt);
}

void Caff(Geek &geek, ElTime &elt)
{
	Computer comp;
	string choice = "show w";

	while(choice[0] != 'd')
	{
		while(choice == "show w" || choice == "show c" )
		{
			cout << readfromfile(MAINFILE,"!CAFFMENU",0);
			cout << readfromfile(MAINFILE,"!PENTER",1);
			getline(cin, choice);
			gpl_check_and_strlwr(choice);
		}
		
		if(choice[0] == 'a')
		{
			string buychoice = "show w";
			
			while(buychoice == "show w" || buychoice == "show c" )
			{
				cout << readfromfile(MAINFILE,"!PBENRGY1",0);
				cout << readfromfile(MAINFILE,"!PBENRGY2",1);
				getline(cin, buychoice);
				gpl_check_and_strlwr(buychoice);
			}
			
			int n = atoi(buychoice.c_str());
			
			if( geek.GetMoney() < (10 * n) )
				cout << readfromfile(MAINFILE,"!NOMONEY",0);
			else if( n > 0 )
				CmdBuyEnergyDrink(geek, elt, n);
		}
		else if(choice[0] == 'b')
		{
			string s = "show w";
			
			while(s == "show w" || s == "show c" )
			{
				cout << readfromfile(MAINFILE,"!PDENRGY1",0);
				cout << readfromfile(MAINFILE,"!PDENRGY2",1);
				getline(cin, s);
				gpl_check_and_strlwr(s);
			}
			
			if( geek.GetEnergyDrinks() <= 0 )
				cout << readfromfile(MAINFILE,"!PNENRGY",0);
			else if(s[0] == 'y')
				CmdDrinkEnergyDrink(geek,elt);
		}
		else if(choice[0] == 'c')
			cout << readfromfilevars(MAINFILE,"!ENSTATS",0,geek,comp,comp,elt,0,0,"","","");
		else if(choice[0] == 'd')
		{
			if( geek.GetEnergy() < 10 )
			{
				cout << readfromfilevars(MAINFILE,"!NOENERGY",0,geek,comp,comp,elt,10,0,"","","");	
				if( geek.GetMoney() < 10 && geek.GetEnergyDrinks() <= 0 )
					return;
			}
			else
			{
				geek.SetEnergy(geek.GetEnergy() - 10);
				return;
			}
		}
		choice = "show w";
	}
}

int Hack(Geek &geek, Computer &comp, ElTime &elt)
{
	string s = "show w";

	while(s == "show w" || s == "show c" )
	{
		cout << readfromfile(MAINFILE,"!HACKGEEK",0);
		cout << readfromfile(MAINFILE,"!PDOIT",1);
		getline(cin, s);
		gpl_check_and_strlwr(s);
	}
	
	if(s[0]=='y')
	{	
		if( geek.GetEnergy() < 50 )
			cout << readfromfilevars(MAINFILE,"!NOENERGY",0,geek,comp,comp,elt,50,0,"","","");	
		else
		{
			if(CmdHack(geek,comp,elt)==-1)
				return -1;
		}
	}
	return 0;
}

void AntiVirus(Geek &geek, Computer &comp, ElTime &elt)
{
	cout << readfromfile(MAINFILE,"!ANTIVIR",0);
	cout << readfromfile(MAINFILE,"!AVSCAN",0);
	
	if(comp.GetInfected() == 0)
	{
		string s = "show w";
		
		while(s == "show w" || s == "show c" )
		{
			cout << readfromfile(MAINFILE,"!AVFOUND",1);
			getline(cin, s);
			gpl_check_and_strlwr(s);
			cout << endl;
		}
		
		if(s[0] == 'y')
		{
			if(geek.GetMoney() < 15)
				cout << readfromfile(MAINFILE,"!NOMONEY",0);
			else
				CmdAntiVirus(geek,comp,elt,15.0);
		}
	}
	else
		cout << readfromfile(MAINFILE,"!NOINFVIR",0); 

}

void WasteTime(Geek &geek,Computer &comp, ElTime &elt)
{
	if( geek.GetEnergy() < 10 )
	{
		cout << readfromfilevars(MAINFILE,"!NOENERGY",0,geek,comp,comp,elt,10,0,"","","");
		return;
	}

	CmdWasteTime(geek,comp,elt);
}

void Sleep(Geek &geek, Computer &comp, ElTime &elt)
{
	string s = "show w";

	while(s == "show w" || s == "show c" )
	{
		cout << readfromfile(MAINFILE,"!SLEEP",0);
		cout << readfromfile(MAINFILE,"!PDOIT",1);
		getline(cin, s);
		gpl_check_and_strlwr(s);
	}
	
	if(s[0]=='y')
		CmdSleep(geek, comp,elt);
}
