/*

The Life of a Geek
Copyright (C) 2003 Daniel Quintiliani

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

You can e-mail Daniel Quintiliani at coredump@coredumpcentral.org

7/4/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Added AddYear().
eltime.h: Elapsed time

*/

#ifndef _ELTIME_H
#define _ELTIME_H

class ElTime
{
	public:
		ElTime();
		ElTime(ElTime& elt);
		~ElTime();
		
		void AddYear(int n);
		int GetYear();
		void AddMonth(int n);
		int GetMonth();
		void AddMDay(int n); // This is not the day of the month,
		        	     // but the days after the month
		int GetMDay();
		void AddHour(int n);
		int GetHour();
		void AddMin(int n);
		int GetMin();

	private:

		void FixTime(); // e.g. 65 min becomes 1 hr 5 mins
		int DaysInMonth(); // Returns days in month
		int Year;
		int Month;
		int MDay;
		int Hour;
		int Min;

};

#endif
