/*

The Life of a Geek
Copyright (C) 2003 Daniel Quintiliani

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

You can e-mail Daniel Quintiliani at coredump@coredumpcentral.org

func.cc: Misc functions

7/9/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Updated LogOff().
7/4/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Added GenEnemy(),
updated readfromfilevars() for enemy computer, added AttackEnemy(),
fixed bug where gpl check wouldn't be done at certain spots, moved
main.cc virus deduction/healing code to DeductVirAndHeal(), updated
FuncGenAttack(), added HackAntiVir(), added UploadVirus(), added LogOff(),
moved truncf() and roundf() to strlwr.c, added Victory(). 
6/14/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Fixed support for
older compilers/C libraries.
6/13/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Added elapsed time
code, changed floattostring() to currencytostring(), added floattocurrency(),
made FuncGenAttack() more random.
5/21/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Updated 
FuncGenAttack().
5/20/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Added 
readfromfilevars(), inttostring(), removed FuncGenGameName() and FuncGenEmu(),
removed the duplicate, unused FuncGenAttack() text file transition now (almost)
complete.
4/24/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Added 
readfromfile().
4/7/03: Daniel Quintiliani <coredump@coredumpcentral.org>: To be more
considerate replaced all bools with ints, added gpl_check_and_strlwr().

*/

#include "func.h"
#include <iostream>
#include <fstream>
#include <sstream>
#include "gpl.h"

#ifndef HAVE_STRLWR
#include "strlwr.h"
#endif

using namespace std;

void FuncGenAttack(Computer &comp, int n)
{
	srand((unsigned)time(NULL));
	float f = (float)100.0 * rand() / (RAND_MAX + 1.0);
	int n2 = (int)roundf(f);
	
	if( n2 < n )
	{
		f = (float)100.0 * rand() / (RAND_MAX + 1.0);
		n2 = (int)roundf(f);
		if( n2 < 50 || comp.GetInfected() == 0)
		{
			Geek geek;
			ElTime elt;
			f = 1.0 + ((float)(comp.GetMaxHealth() / 2) * rand() /
                                    RAND_MAX - comp.GetSecurity()); 
			n2 = (int)roundf(f);
			if(n2>comp.GetMaxHealth()/2) n2=comp.GetMaxHealth()/2;
			if(n2>0)
			{
				string s;
				comp.SetHealth(comp.GetHealth() - n2);
				cout << readfromfilevars(MAINFILE,"!ATTACK",0,geek,
					comp,comp,elt,n2,0,"","","");
		                cout << readfromfile(MAINFILE,"!PAUSE",1);
                		getline(cin,s);
                		gpl_check_and_strlwr(s);
			}
		}
		else
		{
			string s;
			comp.SetInfected(0);
			cout << readfromfile(MAINFILE,"!ATTVIR",0);
	                cout << readfromfile(MAINFILE,"!PAUSE",1);
       		        getline(cin,s);
                	gpl_check_and_strlwr(s);
		}
	}
}

char* gpl_check_and_strlwr(string& s)
{
	char* sz = (char*)s.c_str();
	strlwr(sz);
	s = sz;
	gpl_check(s.c_str());
	return sz;
}

const char* readfromfile(const char* filename, const char* id, int newline)
{
	ifstream ifs(filename);
	string Buffer;
	string Buffer2;

	int eof;
	ifs >> eof;
	getline(ifs,Buffer);
	int n = 0;

	while(n<eof-1)
	{
		string StrFromFile;
		ifs >> StrFromFile;
		getline(ifs,Buffer);
		
		if(strcmp(StrFromFile.c_str(),id)==0)
		{
			if(Buffer == " $END")
				n = eof;
			else
			{
				for(unsigned n2=0;n2<Buffer.size();n2++)
					if(n2 > 0)
						Buffer2 += Buffer[n2];
			
				if(newline == 0)
					Buffer2+='\n';	
			}
		}
		n++;
	}

	ifs.close();
	return Buffer2.c_str();
}

const char* readfromfilevars(const char* filename, const char* id, int newline,
			Geek geek, Computer comp, Computer ecomp, ElTime elt, 
			int intvar, float floatvar, const char* cstrvar,
			const char* YInfected, const char* NInfected)
{
        ifstream ifs(filename);
        string Buffer;
	string Buffer2;

        int eof;
        ifs >> eof;
        getline(ifs,Buffer);
        int n = 0;

        while(n<eof-1)
        {
                string StrFromFile;
                ifs >> StrFromFile;
                getline(ifs,Buffer);

                if(strcmp(StrFromFile.c_str(),id)==0)
                {
                        if(Buffer == " $END")
                                n = eof;
                        else
                        {
                                for(unsigned n2=0;n2<Buffer.size();n2++)
				{
                                        if(n2 > 0)
                                        {
						if(Buffer[n2]=='$')
						{
						if(Buffer[n2+1]=='0')
						{
						Buffer2 += inttostring(intvar);
						n2++;
						}
						else if(Buffer[n2+1]=='1')
						{
						Buffer2 += currencytostring(floatvar);
						n2++;
						}
						else if(Buffer[n2+1]=='2')
						{
						Buffer2 += cstrvar;
						n2++;
						}
					        else if(Buffer[n2+1]=='a')
						{
						Buffer2 += inttostring(geek.GetEnergy());
						n2++;
						}
						else if(Buffer[n2+1]=='b')
						{
						Buffer2 += currencytostring(geek.GetMoney());
						n2++;
						}
						else if(Buffer[n2+1]=='c')
						{
						Buffer2 += geek.GetName();
						n2++;
						}
						else if(Buffer[n2+1]=='d')
						{
						Buffer2+=inttostring(geek.GetEnergyDrinks());
						n2++;
						}
						else if(Buffer[n2+1]=='e')
						{
						Buffer2+=inttostring(geek.GetEducation());
						n2++;
						}
						else if(Buffer[n2+1]=='m')
						{
						if(comp.GetInfected() == 0)
							Buffer2+=YInfected;
						else
							Buffer2+=NInfected;
						n2++;
						}
						else if(Buffer[n2+1]=='n')
						{
						Buffer2+=inttostring(comp.GetHealth());
						n2++;
						}
						else if(Buffer[n2+1]=='o')
						{
						Buffer2+=inttostring(comp.GetMaxHealth());
						n2++;
						}
						else if(Buffer[n2+1]=='p')
						{
						Buffer2+=inttostring(comp.GetSecurity());
						n2++;
						}
						else if(Buffer[n2+1]=='q')
						{
						Buffer2+=inttostring(comp.GetLevel());
						n2++;
						}
						else if(Buffer[n2+1]=='r')
						{
						Buffer2+=inttostring(comp.GetExp());
						n2++;
						}
						else if(Buffer[n2+1]=='s')
						{
						if(ecomp.GetInfected() == 0)
                                                        Buffer2+=YInfected;
                                                else
                                                        Buffer2+=NInfected;
                                                n2++;
						}
						else if(Buffer[n2+1]=='t')
						{
						Buffer2+=inttostring(ecomp.GetHealth());
                                                n2++;
						}
						else if(Buffer[n2+1]=='u')
						{
						Buffer2+=inttostring(ecomp.GetMaxHealth());
                                                n2++;
						}
						else if(Buffer[n2+1]=='v')
                                                {
                                                Buffer2+=inttostring(ecomp.GetSecurity());
                                                n2++;
                                                }
                                                else if(Buffer[n2+1]=='w')
                                                {
                                                Buffer2+=inttostring(ecomp.GetLevel());
                                                n2++;
                                                }
                                                else if(Buffer[n2+1]=='x')
                                                {
                                                Buffer2+=inttostring(ecomp.GetExp());
                                                n2++;
                                                }
						else if(Buffer[n2+1]=='V')
						{
						Buffer2+=LIFEGEEK_VERSION;
						n2++;
						}
						else if(Buffer[n2+1]=='Y')
						{
						Buffer2+=inttostring(elt.GetYear());
						n2++;
						}
						else if(Buffer[n2+1]=='O')
						{
						Buffer2+=inttostring(elt.GetMonth());
						n2++;
						}
						else if(Buffer[n2+1]=='D')
						{
						Buffer2+=inttostring(elt.GetMDay());
						n2++;
						}
						else if(Buffer[n2+1]=='H')
						{
						Buffer2+=inttostring(elt.GetHour());
						n2++;
						}
						else if(Buffer[n2+1]=='M')
						{
						Buffer2+=inttostring(elt.GetMin());
						n2++;
						}
						else
							Buffer2+=Buffer[n2];
						}
						else
							Buffer2+=Buffer[n2];
					}
				}
				if(newline==0)
                			Buffer2+='\n';
              		}
		}
                n++;
        }

        ifs.close();
	return Buffer2.c_str();
}

const char* inttostring(int n)
{
	ostringstream os;
	os << n;
	return (os.str()).c_str();
}

const char* currencytostring(float f)
{
	ostringstream os;
	os << truncf(f) << CURRENCY_SEPARATOR;
	
	if(f==truncf(f))
		os << '0';
	
	float f2 = roundf((f-truncf(f))*100.0);

	if(f2 > 0 && f2 < 10.0)
		os << '0';

	os << f2;
	
	return (os.str()).c_str();
}

float floattocurrency(float f)
{
	return truncf(f) + (roundf((f-truncf(f))*100.0) / 100.0);
}

Computer GenEnemy(Computer comp)
{
	Computer comp2;
	comp2.SetInfected(1);
	
	srand((unsigned)time(NULL));
	float f = (float)25.0 * rand() / RAND_MAX;
	f /= 100.0;
	float f2 = comp.GetMaxHealth() * f;
	float f3 = comp.GetMaxHealth() + roundf(f2);
	comp2.SetHealth((int)f3);
	comp2.SetMaxHealth((int)f3);
	
	f = (float)(f3/4.0) * rand() / RAND_MAX;
	comp2.SetSecurity((int)truncf(f));
	comp2.SetLevel(comp.GetLevel());
	
	return comp2;	
}

void AttackEnemy(Computer &ecomp)
{
	srand((unsigned)time(NULL));
	float f = (float)100.0 * rand() / (RAND_MAX + 1.0);
	if(f<55.0)
	{
		Geek geek;
		ElTime elt;
		srand((unsigned)time(NULL));
		float f2 = 1.0 + ((float)(ecomp.GetMaxHealth() / 2) * 
				 rand() / RAND_MAX -
				 ecomp.GetSecurity());
		int n = (int)roundf(f2);
                if(n>ecomp.GetMaxHealth()/2) n=ecomp.GetMaxHealth()/2;
                if(n>0)
		{
			string s;
			ecomp.SetHealth(ecomp.GetHealth() - n);	
			cout << readfromfilevars(MAINFILE,"!ATTACKS",0,geek,ecomp,
				ecomp,elt,n,0,"","","");
		        cout << readfromfile(MAINFILE,"!PAUSE",1);
        		getline(cin,s);
        		gpl_check_and_strlwr(s);
		}
	}
	else
	{
		string s;	
		cout << readfromfile(MAINFILE,"!ATTACKF",0);
        	cout << readfromfile(MAINFILE,"!PAUSE",1);
        	getline(cin,s);
        	gpl_check_and_strlwr(s);
	}
}

int DeductVirAndHeal(Computer &comp, ElTime elt, int Main)
{
	if( comp.GetHealth() < comp.GetMaxHealth() && Main == 0 )
        	comp.SetHealth(comp.GetHealth() + 1);

        if(comp.GetInfected() == 0)
        {
		Geek geek;
		string s;
	        srand((unsigned)time(NULL));
	        float f = 1 + ((float)
		        (comp.GetMaxHealth() / 2) *
		        rand() / RAND_MAX - comp.GetSecurity());
	        int n = (int)roundf(f);
	        if(n>(comp.GetMaxHealth()/2)) n=comp.GetMaxHealth()/2;
	        if(n>0)
	        {
			comp.SetHealth(comp.GetHealth() - n);
			if(Main==0)
	        		cout << readfromfilevars(MAINFILE,"!LOSTPTS",0,
					geek,comp,comp,elt,n,0, "", "","");
			else
				cout << readfromfilevars(MAINFILE,"!HKATTVIR",0,
					geek,comp,comp,elt,n,0,"","","");
	        	cout << readfromfile(MAINFILE,"!PAUSE",1);
                	getline(cin,s);
                	gpl_check_and_strlwr(s);
		}
	}

	if(comp.GetHealth() <= 0 && Main == 0)
        {
        	cout << readfromfile(MAINFILE,"!LOSER",0);
        	return -1;
        }
	
	if(elt.GetYear() >= 70)
	{
		cout << readfromfile(MAINFILE,"!DIE",0);
		return -1;
	}

	return 0;
}

void HackAntiVir(Geek &geek, Computer &comp)
{
	ElTime elt;
	cout << readfromfilevars(MAINFILE,"!HKANTIVIR",0,geek,comp,comp,elt,0,
		0,"","","");
	cout << readfromfile(MAINFILE,"!AVSCAN",0);
	if(comp.GetInfected()==0)
	{
		string s;
		cout << readfromfile(MAINFILE,"!AVFOUND",1);
		getline(cin,s);
		gpl_check_and_strlwr(s);
		
		if(geek.GetMoney() < 30.0)
		{
			cout << readfromfile(MAINFILE,"!NOMONEY",0);
			return;
		}

		if(s[0]=='y')
			CmdAntiVirus(geek,comp,elt,30.0);
	}
	else
		cout << readfromfile(MAINFILE,"!NOINFVIR",0);
}	 

void UploadVirus(Computer &ecomp)
{
	if(ecomp.GetInfected()==0)
		cout << readfromfile(MAINFILE,"!UVIRA",0);
	else
	{
		srand((unsigned)time(NULL));
		float f = (float)100.0 * rand() / (RAND_MAX + 1.0);
		if(f<25.0)
		{
			ecomp.SetInfected(0);
			cout << readfromfile(MAINFILE,"!UVIRS",0);
		}
		else
			cout << readfromfile(MAINFILE,"!UVIRF",0);	
	}
}	

int LogOff()
{
	srand((unsigned)time(NULL));
	float f = (float)100.0*rand()/(RAND_MAX+1.0);
	if(f<60.0)
	{
		cout << readfromfile(MAINFILE,"!LOGOFFS",0);
		return 0;
	}
	else
	{
		cout << readfromfile(MAINFILE,"!LOGOFFF",0);
		return 1;
	}
}

void Victory(Geek &geek, Computer &comp, ElTime &elt, int Turns)
{
	string s;
	comp.SetExp(comp.GetExp() + (Turns * 10));
	cout << readfromfilevars(MAINFILE,"!VICTORY",0,geek,comp,comp,elt,
				comp.GetExp(),0,"","","");
	cout << readfromfile(MAINFILE,"!PAUSE",1);
	getline(cin,s);
	gpl_check_and_strlwr(s);
	srand((unsigned)time(NULL));
	float f = (float)100.0 * rand() / (RAND_MAX + 1.0);
	if(f<20)
	{
		float f2 = (float)100.0 + 2000.0 * rand() / RAND_MAX;
		f2 = floattocurrency(f2);
		geek.SetMoney(geek.GetMoney() + f2);
		cout << readfromfilevars(MAINFILE,"!VICTORYM",0,geek,comp,
			comp,elt,0,f2,"","","");
		cout << readfromfile(MAINFILE,"!PAUSE",1);
		getline(cin,s);
		gpl_check_and_strlwr(s);
	}
	else if(f>=20 && f<40)
	{
		if(comp.GetSecurity() < (comp.GetMaxHealth() / 4))
		{
			comp.SetSecurity(comp.GetSecurity() + 1);
			cout << readfromfile(MAINFILE,"!VICTORYS",0);
			cout << readfromfile(MAINFILE,"!PAUSE",1);
			getline(cin,s);
			gpl_check_and_strlwr(s);
		}
	}
	else if(f>=40 && f<60)
	{
		elt.AddYear(5);
		cout << readfromfile(MAINFILE,"!GOTOJAIL",0);
		cout << readfromfile(MAINFILE,"!PAUSE",1);
		getline(cin,s);
		gpl_check_and_strlwr(s);
	}
}	
