/*

The Life of a Geek
Copyright (C) 2003 Daniel Quintiliani

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

You can e-mail Daniel Quintiliani at coredump@coredumpcentral.org

version.h: Global variables 

6/14/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Fixed support for
older compilers/C libraries.
6/13/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Now contains
HAVE_STRLWR define and CURRENCY_SEPARATOR.
5/20/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Now contains file
info as well and initialized in version.c. Updated to version 0.22
4/24/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Updated to version
0.21
4/7/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Updated to version
0.2

*/

#ifndef _VERSION_H
#define _VERSION_H

/* ISO C99 math functions

   Uncomment these three lines if your compiler/C library has these ISO C99 
   functions:

   float roundf(float x);
   float truncf(float x);

   glibc 2.1 and later supports them. If you get errors about not finding
   truncf or roundf, comment these three lines out. My code will be used
   instead. */ 
#define _ISOC9X_SOURCE 1
#define _ISOC99_SOURCE 1
#include <features.h>

/* HAVE_STRLWR

   Does your compiler/C library have a char* strlwr(char* sz) function? Cygwin
   does. If you do, uncomment this. Otherwise, my function from 
   strlwr.c/strlwr.h is used. */
/*#define HAVE_STRLWR*/

/* Set the values of these in version.c */
extern char* LIFEGEEK_VERSION;
extern char CURRENCY_SEPARATOR;
extern char* MAINFILE;
extern char* LICENSEFILE;
extern char* WASTEFILE;
extern char* JOBFILE;

#endif
